<template>
    <div v-if="promotions.length" class="promotion-slider my-4 ">
        <swiper
            :loop="promotions.length > 4 || isMobile"
            :slides-per-view="getSliderPerView"
            :navigation="getSliderNavigation"
            :modules="modules"
            :space-between="spaceBettwen"
            :breakpoints="breakpoints"
        >
            <template v-for="(promotion, index) in promotions" :key="index">
              <swiper-slide class="flex justify-center">
            <nuxt-link :to="`/promotion/${promotion.Id}`" :id="`${ID.PROMOTION_INFO}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`">
                <div
                class="pointer w-[389px] h-[166.857px] flex-none order-[0] flex-grow-0 rounded-[8px] overflow-hidden promotion-card-item pointer-events-none"
                >
                <img v-lazy="promotion.ImagePathForDisplay" :alt="promotion.Title" class="w-full h-full object-cover rounded-[8px] hover:scale-105 duration-500">
                </div>
            </nuxt-link>
            </swiper-slide>
            </template>
        </swiper>
    </div>
</template>

<script lang="ts" setup>
import commonHelper from "@/utils/commonHelper";
import { PropType } from "nuxt/dist/app/compat/capi";
import { Navigation, Pagination, type SwiperOptions } from "swiper";

const { getAssetImage } = commonHelper;


const { promotions } = usePromotion();
const modules = [Navigation, Pagination];


const props = defineProps({
  slidesPerView: {
    type: [Number, String],
    default: 3,
  },
  spaceBettwen: {
    type: Number,
    default: 0,
  },
  breakpoints: {
    type: Object as PropType<Record<string, SwiperOptions>>,
    default: () => ({}),
  },
});
const isMobile = useDevice().isMobile;
const getSliderPerView = computed(() => {
  if (typeof props.slidesPerView === "string") {
    return props.slidesPerView;
  }
  return promotions.value.length < props.slidesPerView
    ? promotions.value.length
    : props.slidesPerView;
});
const getSliderNavigation = computed(() => {
  if (typeof props.slidesPerView === "string") return true;
  return promotions.value.length > props.slidesPerView;
});
</script>

<style lang="scss">
.promotion-slider {
  .swiper {
    overflow: hidden;
    width: 100%;
  }
  .swiper-button-prev,
  .swiper-button-next {
    display: none;
  }
}
[layout="playful"][data-device="desktop"] {
  .promotion-slider {
    .swiper-wrapper {
      gap: 16px;
    }
    .swiper {
      .swiper-slide {
        width: 389px !important;
      }
    }
  }
}
// [layout="playful"][data-device="mobile"] {
//   .promotion-slider {
//     .swiper-initialized {
//       padding-left: 16px;
//     }
//   }
// }
</style>

<style scoped>
</style>